// Programming techniques
//
// Lecture 4 - Sorting & searching
// Example 2 - QuickSort
// ------------------------

#include <iostream>
#include <cmath>
#include <cstdlib>
#include <ctime>
#include <iomanip>
using namespace std;

//  Assign random integers to array
void rin(int arr[], int N)
{
    srand(time(0));
    for (int i=0;i<N;i++)
        arr[i]=rand();    
}

// Quick sort of array
// --------------------
void quicksort(int arr[], int low, int high)
{
    int i, j;
    int temp;
    while (high>low) {
        i=low;
        j=high;
        temp=arr[low];
        while (i<j) {
            while (arr[j]>temp)
                j=j-1;
            arr[i]=arr[j];
            while ((i<j) && (arr[i]<=temp))
                i=i+1;
            arr[j]=arr[i]; }
        arr[i]=temp;
        quicksort(arr,low,i-1);
        low=i+1; }
}

// Binary search of array
// ----------------------
int binsearch(const int arr[], int N, int key)
{
    int mid;
    int k=-1;
    bool succ=false;
    int left=0;
    int right=N;
    while (left<=right && !succ) {
        mid=(left+right)/2;
        if (arr[mid]==key) {
            k=mid;
            succ=true; }
        else if (arr[mid]>key)
            right=mid-1;
        else
            left=mid+1;
    }
    return k;   
}   

//  Guessing game
void guess(int arr[], int n)
{
     int num, pos;
     
     do {
         cout<<"\nEnter your guess: ";
         cin>>num;
         pos=binsearch(arr,n,num);
         if (pos<0)
            cout<<"\n  Bad luck! Try again";
         }
     while (pos<0);
     cout<<"\nBRAVO! Your guess was correct!\n"<<endl;
}

int main()
{
    int n;
    int a[10000]; 
       
    cout<<"\nEnter number of random integers (<10 000) ;";
    cin>>n;
    rin(a,n);
    quicksort(a,0,n-1);
    guess(a,n-1);
    
    system("pause");
    return 0;
}

